aboutsummaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorVratko Polak <vrpolak@cisco.com>2021-11-29 16:17:15 +0100
committerTibor Frank <tifrank@cisco.com>2021-12-15 16:11:17 +0000
commitcca05a55f3434d8a031b98f4a496adb8df20c122 (patch)
tree3aba52b9aa4ec929091dd86875461f895b1331fe
parentaa094dc1a834bf89ebd6549a292fedf2446fb682 (diff)
Tox: Add checker for CSIT model version
+ Implementation stub so checker can check already. + Also add documentation stub for the implemented model. + Checker checks also for bumps in documentation version. - Not comparing implementation and documentation version yet. Change-Id: I4d19c00315a1c171de325c4494c28f5210635f32 Signed-off-by: Vratko Polak <vrpolak@cisco.com>
-rw-r--r--docs/model/current/top.rst48
-rw-r--r--resources/libraries/bash/entry/check/model_version.sh65
-rw-r--r--resources/libraries/python/Constants.py3
-rw-r--r--resources/libraries/python/model/__init__.py16
-rw-r--r--tox.ini6
5 files changed, 137 insertions, 1 deletions
diff --git a/docs/model/current/top.rst b/docs/model/current/top.rst
new file mode 100644
index 0000000000..640abe2343
--- /dev/null
+++ b/docs/model/current/top.rst
@@ -0,0 +1,48 @@
+..
+ Copyright (c) 2021 Cisco and/or its affiliates.
+ Licensed under the Apache License, Version 2.0 (the "License");
+ you may not use this file except in compliance with the License.
+ You may obtain a copy of the License at:
+..
+ http://www.apache.org/licenses/LICENSE-2.0
+..
+ Unless required by applicable law or agreed to in writing, software
+ distributed under the License is distributed on an "AS IS" BASIS,
+ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ See the License for the specific language governing permissions and
+ limitations under the License.
+
+
+CSIT model
+^^^^^^^^^^
+
+This document describes what is currently implemented in CSIT,
+especially the export side (UTI), not import side (PAL).
+
+Version
+~~~~~~~
+
+This document is valid for CSIT model version 0.1.0.
+
+It is recommended to use semantic versioning: https://semver.org/
+That means, if the new model misses a field present in the old model,
+bump the major version. If the new model adds a field
+not present in the old model, bump the minor version.
+Any other edit in the implmenetation (or documentation) bumps the patch version.
+If you change value type or formatting,
+consider whether the parser (PAL) understands the new value correctly.
+Renaming a field is the same as adding a new one and removing the old one.
+Parser (PAL) has to know exact major version and minimal minor version,
+and unless bugs, it can ignore patch version and bumped minor version.
+
+UTI
+~~~
+
+UTI stands for Unified Test Interface.
+It mainly focuses on exporting information gathered during test run
+into JSON output files.
+
+Files
+-----
+
+No files are exported yet in this version.
diff --git a/resources/libraries/bash/entry/check/model_version.sh b/resources/libraries/bash/entry/check/model_version.sh
new file mode 100644
index 0000000000..c886447900
--- /dev/null
+++ b/resources/libraries/bash/entry/check/model_version.sh
@@ -0,0 +1,65 @@
+# Copyright (c) 2021 Cisco and/or its affiliates.
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at:
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+set -exuo pipefail
+
+# This file should be executed from tox, as the assumed working directory
+# is different from where this file is located.
+# This file does not have executable flag nor shebang,
+# to dissuade non-tox callers.
+
+# This script runs a two grep commands as "if" conditions,
+# using log files to store the data (generated by git commands) to grep,
+# failing when model implementation edits do not come with model version edit.
+# The contents of the log files may be useful when fail cause is not obvious.
+
+# "set -eu" handles failures from the following two lines.
+BASH_CHECKS_DIR="$(dirname $(readlink -e "${BASH_SOURCE[0]}"))"
+BASH_FUNCTION_DIR="$(readlink -e "${BASH_CHECKS_DIR}/../../function")"
+source "${BASH_FUNCTION_DIR}/common.sh" || {
+ echo "Source failed." >&2
+ exit 1
+}
+
+impl_log="edited_files.log"
+git diff --name-only HEAD~ > "${impl_log}"
+if ! grep -q '^resources/libraries/python/model' "${impl_log}"; then
+ # Failing grep means no model edits.
+ warn "No model implementation edits detected."
+ warn
+ warn "CSIT model version checker: PASS"
+ exit 0
+fi
+const_log="constants_edits.log"
+git diff -U0 HEAD~ -- "resources/libraries/python/Constants.py" > "${const_log}"
+if ! grep -q '^\+ MODEL_VERSION = ' "${const_log}"; then
+ warn "Model implementation edits without version edit detected!"
+ warn "See ${impl_log} and ${const_log} for what was detected."
+ warn
+ warn "CSIT model version checker: FAIL"
+ exit 1
+fi
+doc_log="docs_edits.log"
+git diff -U0 HEAD~ -- "docs/model/current/top.rst" > "${doc_log}"
+if ! grep -q '^\+This document is valid for CSIT model' "${doc_log}"; then
+ warn "Model implementation edits without documentation update detected!"
+ warn "See ${impl_log}, ${const_log} and ${doc_log} for what was detected."
+ warn
+ warn "CSIT model version checker: FAIL"
+ exit 1
+fi
+# TODO: Check constants and docs are specifying the same version.
+warn "Model version and doc are edited, model implementation edits are allowed."
+warn
+warn "CSIT model version checker: PASS"
+exit 0
diff --git a/resources/libraries/python/Constants.py b/resources/libraries/python/Constants.py
index c14ba31c57..f44c6ad95a 100644
--- a/resources/libraries/python/Constants.py
+++ b/resources/libraries/python/Constants.py
@@ -119,6 +119,9 @@ def get_optimistic_bool_from_env(env_var_names):
class Constants:
"""Constants used in CSIT."""
+ # Version for CSIT data model. See docs/model/.
+ MODEL_VERSION = u"0.1.0"
+
# OpenVPP testing directory location at topology nodes
REMOTE_FW_DIR = u"/tmp/openvpp-testing"
diff --git a/resources/libraries/python/model/__init__.py b/resources/libraries/python/model/__init__.py
new file mode 100644
index 0000000000..36e32b89c4
--- /dev/null
+++ b/resources/libraries/python/model/__init__.py
@@ -0,0 +1,16 @@
+# Copyright (c) 2021 Cisco and/or its affiliates.
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at:
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+"""
+__init__ file for directory resources/libraries/python/model
+"""
diff --git a/tox.ini b/tox.ini
index 3783bba4ff..2084e5abdf 100644
--- a/tox.ini
+++ b/tox.ini
@@ -26,7 +26,7 @@
[tox]
# Fast and brief checkers to front, slow or verbose checkers to back.
-envlist = job_spec, copyright_year, gpl_license,
+envlist = job_spec, copyright_year, gpl_license, model_version,
new_line_length, line_length, autogen, pylint, doc_verify
# The following is needed as tox requires setup.py by default.
@@ -76,6 +76,10 @@ ignore_outcome = true
whitelist_externals = /bin/bash
commands = bash {[tox]checker_dir}/line.sh
+[testenv:model_version]
+whitelist_externals = /bin/bash
+commands = bash {[tox]checker_dir}/model_version.sh
+
[testenv:new_line_length]
# Adding .svg, big .rst tables, .yaml and similar still requires long lines.
# As current implementation is too dumb to filter those out,